# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import glob
import re
import json





def update_package():
    # Declaring local variables
    package_updated = False
    
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()

  
    # Regex pour capturer les versions sous forme de dossiers "1.3.3/"
    re_versions = re.compile(r'<a href="([\d\.]+/)"')
    index = wgets("https://update.flipperzero.one/builds/qFlipper/", proxies=proxies)

    # Capturer et filtrer les versions
    versions = re_versions.findall(index)
    versions = [v.rstrip('/') for v in versions if v != '../']  # Enlever le slash final et ignorer le parent
    print("Versions filtrées : ", versions)

    if not versions:
        print("Aucune version trouvée.")
        return

    latest_version = None

    for version_str in sorted(versions, key=Version, reverse=True):
        if control.architecture == "x64":
            latest_bin = f"qFlipperSetup-64bit-{version_str}.exe"
            download_url = f"https://update.flipperzero.one/builds/qFlipper/{version_str}/{latest_bin}"

            if requests.head(download_url, proxies=proxies).status_code != 404:
                latest_version = version_str
                break


    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
        package_updated = True
    else:
        print("Binary is present: %s" % latest_bin)


    # Deleting outdated binaries
    for f in glob.glob('*.exe'):
        if f != latest_bin:
            remove_file(f)

       
    
    # Mettre à jour le package
    control.set_software_version(latest_version)
    control.save_control_to_wapt()    
        

